View Issue Details

IDProjectCategoryView StatusLast Update
0030115Open CASCADEOCCT:Data Exchangepublic2022-02-07 14:29
Reporterskl Assigned Tobugmaster  
PrioritynormalSeverityfeature 
Status closedResolutionfixed 
Target Version7.4.0Fixed in Version7.4.0 
Summary0030115: Data Exchange - Implementation of import from XCAF to VRML.
DescriptionIt is needed to implement import from TDocStd_Document to VRML format with supporting structure, colors and names for shapes represented by triangulation.
Steps To ReproduceUse new command "WriteVrml" for check.
TagsNo tags attached.
Test case numberNot needed

Relationships

parent of 0030409 closedapn Open CASCADE Data Exchange - exception during VRML file export 
parent of 0032819 resolveddpasukhi Community Data Exchange - VrmlAPI_Writer does not write all colors 
parent of 0032820 resolveddpasukhi Open CASCADE Data Exchange - add VRML reader to XCAF document 
related to 0030180 closedbugmaster Open CASCADE Data Exchange - VrmlAPI_Writer is expected to return export state 
related to 0030221 closedapn Open CASCADE Data Exchange - VRML is exported with inversed normals 
Not all the children of this issue are yet resolved or closed.

Activities

git

2018-09-06 12:41

administrator   ~0079013

Branch CR30115 has been created by skl.

SHA-1: 9ca6468f9105871054ff48c16f678c598cd4eabf


Detailed log of new commits:

Author: skl
Date: Thu Sep 6 11:18:13 2018 +0300

    0030115: Implementation of import from XCAF to VRML.

kgv

2018-09-06 13:00

developer   ~0079014

+    if (aFace.IsNull() == Standard_False) {

Please don't use this style in new code - IsNull() returns a "bool" and there is no need to compare it with "true" or "false" like this.

+  filebuf aFoc;
+  ostream outStream(&aFoc);
+  if (aFoc.open(theFile, ios::out))

This is broken for working with UNICODE file paths on Windows - please use OSD_OpenStream() instead (and correct the other place in file too).

git

2018-09-06 14:02

administrator   ~0079016

Branch CR30115 has been updated forcibly by skl.

SHA-1: 4a83b140a5dd6da2e7372cca355f66d25c9c7bae

git

2018-09-10 11:59

administrator   ~0079080

Branch CR30115 has been updated forcibly by skl.

SHA-1: 25f30ecc8193f1a7f0c56a7c3965383ce8db03d0

git

2018-09-10 12:14

administrator   ~0079081

Branch CR30115 has been updated forcibly by skl.

SHA-1: 877ae5347f373464afc6739ddbcaa36ddbbdfdd9

git

2018-09-11 17:17

administrator   ~0079128

Branch CR30115_1 has been created by anv.

SHA-1: a72abface182dc355ac5d1bd8ccea483a03fee76


Detailed log of new commits:

Author: anv
Date: Tue Sep 11 17:14:24 2018 +0300

    OCCT Samples dependencies fix

kgv

2018-09-11 18:15

developer   ~0079131

--- a/samples/CSharp/OCCTProxy_D3D/OCCTProxy_D3D.vcxproj
+++ b/samples/CSharp/OCCTProxy_D3D/OCCTProxy_D3D.vcxproj
@@ -94,6 +94,7 @@
       <DebugInformationFormat>ProgramDatabase</DebugInformationFormat>
     </ClCompile>
     <Link>
+      <AdditionalDependencies>TKLCAF.lib;%(AdditionalDependencies)</AdditionalDependencies>
       <OutputFile>$(OutDir)OCCTProxy_D3D.dll</OutputFile>

This is inconsistent to other linkage properties of projects OCCTProxy.vcxproj, OCCTProxy_D3D.vcxproj, which defined libraries using pragma in .cpp.

kgv

2018-09-11 18:50

developer   ~0079132

Last edited: 2018-09-11 18:51

> VRML provides no capability to define units of measure.
> All linear distances are assumed to be in meters and all angles are in radians.

  /**
   * Constructor.
   * @param theScene
   *   Scene receiving all Vrml data.
   * @param theScale
   *   Scale factor, considering that VRML standard specifies coordinates in
   *   meters. So if your data are in mm, you should provide theScale=0.001
   */
  inline VrmlData_ShapeConvert (VrmlData_Scene&     theScene,
                                const Standard_Real theScale = 1.)
    : myScene (theScene),
      myScale (theScale)
  {}

I don't see unit scale being set within the patch, so that supposedly generated file has wrong length units
(considering that OCCT uses millimeters ("xstep.gui.unit") by default and VRML is forced to meters).

git

2018-09-12 12:52

administrator   ~0079148

Branch CR30115_1 has been updated forcibly by anv.

SHA-1: 231e9406454f7cfbe75521ebe2415108984b9f50

git

2018-09-21 07:30

administrator   ~0079301

Branch CR30115 has been updated forcibly by skl.

SHA-1: 558c581b84d6734ca0b788b107a658d40fa4ea52

git

2018-09-21 14:19

administrator   ~0079312

Branch CR30115 has been updated by skl.

SHA-1: aad3f40e5102e0eb88a35ce902090399fe806ae2


Detailed log of new commits:

Author: anv
Date: Tue Sep 11 17:14:24 2018 +0300

    OCCT Samples dependencies fix

kgv

2018-09-21 16:37

developer   ~0079319

Please don't forget about OSD_OpenStream() remark.

git

2018-09-24 16:11

administrator   ~0079368

Branch CR30115 has been updated by skl.

SHA-1: b5ae45bea5e85272002ee6d80788a70ea90acebd


Detailed log of new commits:

Author: skl
Date: Mon Sep 24 16:10:31 2018 +0300

    Correction for VRML writer.

git

2018-09-24 17:27

administrator   ~0079370

Branch CR30115 has been updated forcibly by skl.

SHA-1: e69c78aadd16157bd6f1a2d3b68d6a5813164c6e

skl

2018-09-26 14:45

developer   ~0079410

Branch CR30115 and CR30115prod are ready to be reviewed.

Results of tests:
http://vm-jenkins-test-12.nnov.opencascade.com:8080/view/CR30115-CR30115prod-SKL/view/COMPARE/

git

2018-09-26 17:25

administrator   ~0079416

Branch CR30115 has been updated forcibly by skl.

SHA-1: 639c3685dce51f05f87867a9b36f3c81f45dfef4

gka

2018-09-26 19:16

developer   ~0079418

File VrmlData_ShapeConvert.cxx:
Please:
Remove redundant commented lines 282-406.
Add comment in line 456.
Correct lines 784-799 to define variable findColor by conditional expression.
Replace lines 828-833, 868-871 on the method gp_Trsf::SetScaleFactor
Remove empty "if" expression from lines 893-895
Remove redundant "if" expression from lines 993-995

git

2018-09-27 08:15

administrator   ~0079426

Branch CR30115 has been updated forcibly by skl.

SHA-1: 6d3d6a7f9dd15a43908338f069abb83281570e67

skl

2018-09-27 08:16

developer   ~0079427

Branch CR30115 and CR30115prod are ready to be reviewed.

skl

2018-09-27 16:56

developer   ~0079455

Results of tests:
http://vm-jenkins-test-12.nnov.opencascade.com:8080/view/CR30115-CR30115prod-SKL/view/COMPARE/

gka

2018-09-27 17:01

developer   ~0079456

Branch CR30115 and CR30115prod were reviewed

bugmaster

2018-09-27 19:23

administrator   ~0079458

Combination -
OCCT branch : CR30115 SHA - 6d3d6a7f9dd15a43908338f069abb83281570e67
Products branch : CR30115prod SHA - 565c4463227b5d904cea1fa269fca32b5f2dee60
was compiled on Linux, MacOS and Windows platforms and tested in optimize mode.

Number of compiler warnings:
No new/fixed warnings

Regressions/Differences/Improvements:
No regressions/differences

CPU differences:
Debian80-64:
OCCT
Total CPU difference: 17403.139999999785 / 17379.439999999933 [+0.14%]
Products
Total CPU difference: 7465.760000000061 / 7467.690000000077 [-0.03%]
Windows-64-VC14:
OCCT
Total CPU difference: 17520.285108798456 / 17536.33761169853 [-0.09%]
Products
Total CPU difference: 8367.706438799994 / 8382.276932199968 [-0.17%]


Image differences :
No differences that require special attention

Memory differences :
No differences that require special attention

git

2018-09-30 18:47

administrator   ~0079506

Branch CR30115 has been deleted by inv.

SHA-1: 6d3d6a7f9dd15a43908338f069abb83281570e67

git

2018-09-30 18:48

administrator   ~0079525

Branch CR30115_1 has been deleted by inv.

SHA-1: 231e9406454f7cfbe75521ebe2415108984b9f50

Related Changesets

occt: master a3506de7

2018-09-06 08:18:13

skl


Committer: bugmaster Details Diff
0030115: Implementation of import from XCAF to VRML. Affected Issues
0030115
mod - samples/CSharp/OCCTProxy/OCCTProxy.cpp Diff File
mod - samples/CSharp/OCCTProxy_D3D/OCCTProxyD3D.cpp Diff File
mod - samples/mfc/standard/05_ImportExport/adm/win/vc10/ImportExport.vcxproj Diff File
mod - samples/mfc/standard/mfcsample/adm/win/vc10/mfcsample.vcxproj Diff File
mod - samples/qt/IESample/IESample.pro Diff File
mod - samples/qt/Tutorial/Tutorial.pro Diff File
mod - src/TKVRML/EXTERNLIB Diff File
mod - src/TKXDEDRAW/EXTERNLIB Diff File
mod - src/TKXSDRAW/EXTERNLIB Diff File
mod - src/VrmlAPI/VrmlAPI_Writer.cxx Diff File
mod - src/VrmlAPI/VrmlAPI_Writer.hxx Diff File
mod - src/VrmlData/VrmlData_ShapeConvert.cxx Diff File
mod - src/VrmlData/VrmlData_ShapeConvert.hxx Diff File
mod - src/XDEDRAW/XDEDRAW_Common.cxx Diff File

Issue History

Date Modified Username Field Change
2018-09-06 12:26 skl New Issue
2018-09-06 12:26 skl Assigned To => gka
2018-09-06 12:41 git Note Added: 0079013
2018-09-06 12:55 kgv Assigned To gka => skl
2018-09-06 12:55 kgv Severity minor => feature
2018-09-06 12:55 kgv Status new => assigned
2018-09-06 12:55 kgv Summary Implementation of import from XCAF to VRML. => Data Exchange - Implementation of import from XCAF to VRML.
2018-09-06 13:00 kgv Note Added: 0079014
2018-09-06 14:02 git Note Added: 0079016
2018-09-10 11:59 git Note Added: 0079080
2018-09-10 12:14 git Note Added: 0079081
2018-09-11 17:17 git Note Added: 0079128
2018-09-11 18:15 kgv Note Added: 0079131
2018-09-11 18:50 kgv Note Added: 0079132
2018-09-11 18:51 kgv Note Edited: 0079132
2018-09-12 12:52 git Note Added: 0079148
2018-09-21 07:30 git Note Added: 0079301
2018-09-21 14:19 git Note Added: 0079312
2018-09-21 16:37 kgv Note Added: 0079319
2018-09-24 16:11 git Note Added: 0079368
2018-09-24 17:27 git Note Added: 0079370
2018-09-26 14:45 skl Note Added: 0079410
2018-09-26 14:47 skl Assigned To skl => gka
2018-09-26 14:47 skl Status assigned => resolved
2018-09-26 14:47 skl Steps to Reproduce Updated
2018-09-26 17:25 git Note Added: 0079416
2018-09-26 18:29 gka Assigned To gka => skl
2018-09-26 18:29 gka Status resolved => assigned
2018-09-26 19:16 gka Note Added: 0079418
2018-09-27 08:15 git Note Added: 0079426
2018-09-27 08:16 skl Note Added: 0079427
2018-09-27 08:16 skl Assigned To skl => gka
2018-09-27 08:16 skl Status assigned => resolved
2018-09-27 16:56 skl Note Added: 0079455
2018-09-27 17:01 gka Note Added: 0079456
2018-09-27 17:01 gka Assigned To gka => bugmaster
2018-09-27 17:01 gka Status resolved => reviewed
2018-09-27 19:23 bugmaster Note Added: 0079458
2018-09-27 19:23 bugmaster Status reviewed => tested
2018-09-27 19:25 bugmaster Test case number => Not needed
2018-09-30 18:26 bugmaster Changeset attached => occt master a3506de7
2018-09-30 18:26 bugmaster Status tested => verified
2018-09-30 18:26 bugmaster Resolution open => fixed
2018-09-30 18:47 git Note Added: 0079506
2018-09-30 18:48 git Note Added: 0079525
2018-09-30 22:21 kgv Relationship added related to 0030180
2018-10-09 11:02 kgv Relationship added related to 0030221
2018-12-12 16:13 kgv Relationship added parent of 0030409
2022-02-07 14:06 kgv Relationship added parent of 0032819
2022-02-07 14:29 kgv Relationship added parent of 0032820